(define MNTPATHLEN 1024)
(define MNTNAMLEN 255)
(define FHSIZE 32)
(define char xdr-integer)
(define fhandle
  (make-xdr-fixed-length-opaque-array FHSIZE))
(define fhstatus
  (make-xdr-union-type
    xdr-unsigned-integer
    `((0 unquote fhandle))
    xdr-void))
(define dirpath (make-xdr-string MNTPATHLEN))
(define name (make-xdr-string MNTNAMLEN))
(define exportnode
  (make-xdr-struct-type
    (list dirpath
          (lambda () groups)
          (lambda () exports))))
(define groupnode
  (make-xdr-struct-type
    (list name (lambda () groups))))
(define exports
  (make-xdr-union-type
    xdr-boolean
    `((TRUE unquote (lambda () exportnode))
      (FALSE unquote xdr-void))
    #f))
(define groups
  (make-xdr-union-type
    xdr-boolean
    `((TRUE unquote (lambda () groupnode))
      (FALSE unquote xdr-void))
    #f))
(define mountbody
  (make-xdr-struct-type
    (list name dirpath (lambda () mountlist))))
(define mountlist
  (make-xdr-union-type
    xdr-boolean
    `((TRUE unquote (lambda () mountbody))
      (FALSE unquote xdr-void))
    #f))
(define (make-MOUNTPROG-server versions+procs)
  (define %program-versions
    `(("MOUNTVERS"
       1
       ("MOUNTPROC_NULL" 0 ,xdr-void ())
       ("MOUNTPROC_MNT" 1 ,fhstatus (,dirpath))
       ("MOUNTPROC_DUMP" 2 ,mountlist ())
       ("MOUNTPROC_UMNT" 3 ,xdr-void (,dirpath))
       ("MOUNTPROC_UMNTALL" 4 ,xdr-void ())
       ("MOUNTPROC_EXPORT" 5 ,exports ())
       ("MOUNTPROC_EXPORTALL" 6 ,exports ()))))
  (make-rpc-program
    100005
    (filter-map
      (lambda (version+procs)
        (let* ((name (car version+procs))
               (version (assoc name %program-versions)))
          (and version
               (let ((number (car (cdr version)))
                     (user-procs (cdr version+procs)))
                 (make-rpc-program-version
                   number
                   (let ((version-procs (cddr version)))
                     (filter-map
                       (lambda (user-proc)
                         (let* ((name (car user-proc))
                                (handler (cdr user-proc))
                                (proc (assoc name version-procs)))
                           (and proc
                                (let ((number (car (cdr proc)))
                                      (ret-type (cadr (cdr proc)))
                                      (arg-types (caddr (cdr proc))))
                                  (make-rpc-procedure
                                    number
                                    (cond ((null? arg-types) xdr-void)
                                          ((null? (cdr arg-types))
                                           (car arg-types))
                                          (else
                                           (apply make-xdr-struct-type
                                                  arg-types)))
                                    ret-type
                                    handler)))))
                       user-procs)))))))
      versions+procs)))
